#library "IKADOOM"
#include "zcommon.acs"

int IkarugaUnleashAlert[64];
int ChainCure[64];
int IkarugaUnleashCounter[64];

Script "ChangeShield" (void) NET
{
    SetHudSize(480, 300, FALSE);
	if (CheckInventory("IkaDoomRedShield"))
	    {
		HudMessage(s:"Blue Shield";HUDMSG_FADEINOUT,10,CR_LIGHTBLUE,240.0,280.0,1.0);
		SetFont("IKDRCHBL");
		HudMessage(s:"A";HUDMSG_FADEINOUT,20,CR_LIGHTBLUE,240.0,300.0,0.5,0.5,0.5);
		FadeRange (0, 0, 255, 0.07, 0, 0, 0, 0.0, 1.0);
		ActivatorSound("IkaDoom/ChangeShield",127);
	    TakeInventory("IkaDoomRedShield", 1);
		GiveInventory("IkaDoomBlueShield", 1);
		}
	else
	    {
		HudMessage(s:"Red Shield";HUDMSG_FADEINOUT,10,CR_DARKRED,240.0,280.0,1.0);
		SetFont("IKDRCHRE");
		HudMessage(s:"A";HUDMSG_FADEINOUT,20,CR_LIGHTBLUE,240.0,300.0,0.5,0.5,0.5);
		FadeRange (255, 0, 0, 0.07, 0, 0, 0, 0.0, 1.0);
		ActivatorSound("IkaDoom/ChangeShield",127);
		TakeInventory("IkaDoomBlueShield", 1);
		GiveInventory("IkaDoomRedShield", 1);
		}
}

Script "UnleashReadySound" enter
{
    if(CheckInventory("IkarugaShieldPower")==40 && IkarugaUnleashAlert[PlayerNumber()]==0)
	{
	    SetHudSize(480, 300, FALSE);
        ActivatorSound("IkaDoom/UnleashReady",127);
		HudMessage(s:"Energy Max";HUDMSG_FADEINOUT,11,CR_YELLOW,240.0,270.0,1.0);
		FadeRange (255, 255, 255, 0.2, 0, 0, 0, 0.0, 1.0);
		IkarugaUnleashAlert[PlayerNumber()]=1;
	}
	Delay(5);
	Restart;
}

Script "UnleashReadySoundTwo" respawn
{
    if(CheckInventory("IkarugaShieldPower")==40 && IkarugaUnleashAlert[PlayerNumber()]==0)
	{
	    SetHudSize(480, 300, FALSE);
        ActivatorSound("IkaDoom/UnleashReady",127);
		HudMessage(s:"Energy Max";HUDMSG_FADEINOUT,11,CR_YELLOW,240.0,270.0,1.0);
		FadeRange (255, 255, 255, 0.2, 0, 0, 0, 0.0, 1.0);
		IkarugaUnleashAlert[PlayerNumber()]=1;
	}
	Delay(5);
	Restart;
}

Script "Unleash" (void) NET
{
		if(CheckInventory("IkarugaShieldPower")<4)
		terminate;
		
		While (CheckInventory("IkarugaShieldPower")>3)
		{
		   TakeInventory("IkarugaShieldPower", 4);
		   IkarugaUnleashCounter[PlayerNumber()]++;
		}
		
 		GiveInventory(Strparam(s:"UnleashItemActivator",d:IkarugaUnleashCounter[PlayerNumber()]),1);
		IkarugaUnleashAlert[PlayerNumber()]=0;
		IkarugaUnleashCounter[PlayerNumber()]=0;
		ActivatorSound("IkaDoom/UnleashFire",127);
		FadeRange (255, 255, 255, 0.2, 0, 0, 0, 0.0, 1.0);
}

script "FireReturn" (void)
{
    SetResultValue(GetCVar("ikaruga_return"));
}

script "ChainMechanic" KILL 
{	
	
	if(!CheckFlag(0, "ISMONSTER"))
	{
		terminate;
	}
	
	Bool joer=CheckFlag(0,"PUFFGETSOWNER"); 
	If(joer)
	{
	    SetActivatorToTarget(0);
		if(CheckInventory("IkaDoomBlueChainCounter")>=1)
		{
		ChainCure[PlayerNumber()]=0;
		TakeInventory("IkaDoomChainCounter", 999);
		TakeInventory("IkaDoomBlueChainCounter", 999);
		TakeInventory("IkaDoomRedChainCounter", 999);
		}
		else
		{
		GiveInventory("IkaDoomRedChainCounter", 1);
		}
	}
	else 
	{
	    SetActivatorToTarget(0);
		if(CheckInventory("IkaDoomRedChainCounter")>=1)
		{
		ChainCure[PlayerNumber()]=0;
		TakeInventory("IkaDoomChainCounter", 999);
		TakeInventory("IkaDoomBlueChainCounter", 999);
		TakeInventory("IkaDoomRedChainCounter", 999);
		}
		else
		{
		GiveInventory("IkaDoomBlueChainCounter", 1);
		}
	}
	
	if(CheckInventory("IkaDoomBlueChainCounter")==3 || CheckInventory("IkaDoomRedChainCounter")==3)
	   {
	       SetHudSize(480, 300, FALSE);
           TakeInventory("IkaDoomBlueChainCounter", 999);
	   	   TakeInventory("IkaDoomRedChainCounter", 999);
		   if(ChainCure[PlayerNumber()]<10)
           ChainCure[PlayerNumber()]++;
		   HealThing(ChainCure[PlayerNumber()],400);
		   GiveInventory("IkaDoomChainCounter", 1);
		   ActivatorSound("IkaDoom/ChainDone",127);
		   HudMessage(s:"Chain ", d:ChainCure[PlayerNumber()], s:" Completed!";HUDMSG_FADEINOUT,12,CR_WHITE,240.0,260.0,1.0);
	   }
}

script "ShieldOne" enter
{
    GiveInventory("IkaDoomBlueShield", 1);
}

script "ShieldTwo" respawn
{
    GiveInventory("IkaDoomBlueShield", 1);
}

script "ShieldIconOne" ENTER
{
    int ZANDROSUCKS = GetActorZ(0) + 100.0;
	
    if(GameType() == GAME_SINGLE_PLAYER)
	{
		terminate;
	}
    
	if(CheckInventory("IkaDoomBlueShield"))
	{
	       SpawnForced("IkaDoomBlueShieldIcon", GetActorX(0), GetActorY(0), ZANDROSUCKS);
	       delay(1);
	       restart;
    }
	else
	{
	       SpawnForced("IkaDoomRedShieldIcon", GetActorX(0), GetActorY(0), ZANDROSUCKS);
	       delay(1);
	       restart;
	}
}

script "ShieldIconTwo" RESPAWN
{
    int ZANDROSUCKS = GetActorZ(0) + 100.0;
	
    if(GameType() == GAME_SINGLE_PLAYER)
	{
		terminate;
	}
    
	if(CheckInventory("IkaDoomBlueShield"))
	{
	       SpawnForced("IkaDoomBlueShieldIcon", GetActorX(0), GetActorY(0), ZANDROSUCKS);
	       delay(1);
	       restart;
    }
	else
	{
	       SpawnForced("IkaDoomRedShieldIcon", GetActorX(0), GetActorY(0), ZANDROSUCKS);
	       delay(1);
	       restart;
	}
}